#Region "Copyright (C) 2012 James D Westoby"
'  
'  *	Copyright (C) 2012 James D Westoby
'  *
'  *  This Program is free software you can redistribute it and/or modify
'  *  it under the terms of the GNU General Public License as published by
'  *  the Free Software Foundation either version 2, or (at your option)
'  *  any later version.
'  *   
'  *  This Program is distributed in the hope that it will be useful,
'  *  but WITHOUT ANY WARRANTY without even the implied warranty of
'  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'  *  GNU General Public License for more details.
'  *   
'  *  You should have received a copy of the GNU General Public License
'  *  along with GNU Make see the file COPYING.  If not, write to
'  *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
'  *  http:'www.gnu.org/copyleft/gpl.html
'  *
'  */


#End Region

Imports System
Imports System.Text


Imports MediaPortal.Core
Imports MediaPortal.Configuration
Imports MediaPortal.Dialogs
Imports MediaPortal.GUI.Library


 
Namespace InternetRadioPlugin
    Public Class InternetRadioCommon
        Public Const ConfigForm As Integer = 7283
        Public Const ConfigSkin As String = "\InternetRadioConfig.xml"

        Public Const MainForm As Integer = 7382
        Public Const MainSkin As String = "\InternetRadioMain.xml"

        Public Const NewName As String = "?"

        Private Const myConfig As String = "InternetRadio.xml"  'Config filename
        Private mySettings As MediaPortal.Profile.Settings = Nothing

        Private myID As Integer                                 'parent window, main or config
        Private myStations() As String


#Region "Constructors/Destructor"

        Public Sub New(ByVal WID As Integer)
            myID = WID
            mySettings = New MediaPortal.Profile.Settings(MediaPortal.Configuration.Config.GetFile(MediaPortal.Configuration.Config.Dir.Config, myConfig))
            ReDim myStations(0) : myStations(0) = NewName & "||about:blank"

            ConfigLoad()
        End Sub

#End Region


#Region "Public Methods"

        Public Sub Add(ByRef Name As String, ByRef Title As String, ByRef URL As String)
            if (Name = "") then return
            if (Title = "") then return
            if (URL = "") then return
            
            Dim i As Integer = Index(Name)
            If (i = -1) Then
                Dim m As Integer = UBound(myStations) + 1
                ReDim Preserve myStations(m)
                i = m
            End If

            myStations(i) = Name & "|" & Title & "|" & URL
        End Sub


        Public Sub ConfigLoad()
            Dim m As Integer = mySettings.GetValueAsInt("Radio", "Count", 0)
            ReDim Preserve myStations(m)
            For i As Integer = 1 To m
                Dim s As String = mySettings.GetValue("Radio", "" & i)
                Dim v() As String = Split(s, "|")
                'correct line format?
                If (UBound(v) = 2) Then myStations(i) = s
            Next i

        End Sub


        Public Sub ConfigSave()
            Dim m As Integer = UBound(myStations)
            mySettings.SetValue("Radio", "Count", m)

            For i As Integer = 1 To m
                mySettings.SetValue("Radio", "" & i, myStations(i))
            Next i
        End Sub


        Public Function Count() As Integer
            Return (UBound(myStations))
        End Function


        Public Sub Delete(ByRef Name As String)
            If (Name = "") Then Return
            Dim i As Integer = Index(Name)
            If (i <= 0) Then Return
            For r As Integer = i To (UBound(myStations) - 1)
                myStations(r) = myStations(r + 1)
            Next r
            ReDim Preserve myStations(Count() - 1)
        End Sub


        Public Function EnterRequest(ByVal Initial As String) As String
            'get info from the virtual keyboard, if not just send back the original string
            Dim k As VirtualKeyboard = CType(GUIWindowManager.GetWindow(CType(GUIWindow.Window.WINDOW_VIRTUAL_KEYBOARD, Integer)), VirtualKeyboard)
            If k Is Nothing Then Return ("")

            k.Reset()
            k.SetLabelAsInitialText(False)
            k.Text = Initial
            k.DoModal(myID)
            If (k.IsConfirmed) Then Return (k.Text) Else Return (Initial)
        End Function


        Public Function Name(ByRef Index As Integer) As String
            If (UBound(myStations) < Index) Then Return ("")
            Dim v() As String = Split(myStations(Index), "|")
            Return (v(0))
        End Function


        Public ReadOnly Property Text(ByVal Val As String) As String
            Get
                Dim v As String = mySettings.GetValue("Translate", Val)
                Return (CType(IIf((v = ""), Val, v), String))
            End Get
        End Property


        Public Function Title(ByRef Name As String) As String
            Dim i As Integer = Index(Name)
            If (UBound(myStations) < i) Then Return ("")
            Dim v() As String = Split(myStations(i), "|")
            Return (v(1))
        End Function


        Public Function URL(ByRef Name As String) As String
            Dim i As Integer = Index(Name)
            If (UBound(myStations) < i) Then Return ("")
            Dim v() As String = Split(myStations(i), "|")
            Return (v(2))
        End Function

#End Region


#Region "Private Methods"

        Private Function Index(ByRef Name As String) As Integer
            For i As Integer = 0 To UBound(myStations)
                Dim v() As String = Split(myStations(i), "|")
                If (v(0) = Name) Then Return (i)
            Next i
            Return (-1)
        End Function

#End Region

    End Class

End Namespace
