#Region "Copyright (C) 2012 James D Westoby"

'Copyright (C) 2012 James D Westoby
'
' This Program is free software you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation either version 2, or (at your option)
' any later version.
'  
' This Program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'  
' You should have received a copy of the GNU General Public License
' along with GNU Make see the file COPYING.  If not, write to
' the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
' http:'www.gnu.org/copyleft/gpl.html

#End Region

Imports System

Imports MediaPortal.Dialogs
Imports MediaPortal.GUI.Library
 


Namespace InternetRadioPlugin
    Public Class InternetRadioConfig
        Inherits GUIWindow

        <SkinControl(11)> Protected buttonSave As GUIButtonControl = Nothing
        <SkinControl(12)> Protected buttonDelete As GUIButtonControl = Nothing

        <SkinControl(21)> Protected buttonName As GUIButtonControl = Nothing
        <SkinControl(22)> Protected buttonTitle As GUIButtonControl = Nothing
        <SkinControl(23)> Protected buttonURL As GUIButtonControl = Nothing

        <SkinControl(29)> Protected labelStatus As GUILabelControl = Nothing

        Private myCommon As InternetRadioCommon = Nothing   'access common routines, values etc.

        Private myName As String
        Private myTitle As String
        Private myURL As String


#Region "ISetupFormMembers"

        Public Function Author() As String
            Return ("James D Westoby")
        End Function


        Public Function Description() As String
            Return ("Internet Radio")
        End Function


        Public Function CanEnable() As Boolean
            Return (False)
        End Function


        Public Function DefaultEnabled() As Boolean
            Return (False)
        End Function


        Public Function GetHome(ByRef strButtonText As String, ByRef strButtonImage As String, ByRef strButtonImageFocus As String, ByRef strPictureImage As String) As Boolean
            strButtonText = String.Empty
            strButtonImage = String.Empty
            strButtonImageFocus = String.Empty
            strButtonImage = String.Empty
            strPictureImage = String.Empty
            Return (False)
        End Function


        Public Overrides Property GetID() As Integer
            Get
                Return (GetWindowId())
            End Get
            Set(ByVal value As Integer)
                'donothing
            End Set
        End Property


        Public Function GetWindowId() As Integer
            Return (InternetRadioCommon.ConfigForm)
        End Function


        Public Function HasSetup() As Boolean
            Return (True)
        End Function


        Public Function PluginName() As String
            Return ("Internet Radio Config")
        End Function


        Public Sub ShowPlugin()
            'configure inside MediaPortal
        End Sub

#End Region


#Region "Override methods"

        Public Overrides Function Init() As Boolean
            myCommon = New InternetRadioCommon(GetWindowId())
            Return (Load(GUIGraphicsContext.Skin & InternetRadioCommon.ConfigSkin))
        End Function


        Protected Overrides Sub OnClicked(ByVal controlId As Integer, ByVal control As GUIControl, ByVal actionType As MediaPortal.GUI.Library.Action.ActionType)
            Try
                If (control Is buttonSave) Then OnButtonSave()
                If (control Is buttonDelete) Then OnButtonDelete()

                If (control Is buttonName) Then myName = myCommon.EnterRequest(myName)
                If (control Is buttonTitle) Then myTitle = myCommon.EnterRequest(myTitle)
                If (control Is buttonURL) Then myURL = myCommon.EnterRequest(myURL)
            Catch ex As Exception
                'donothing, failed though!
            End Try

            MyBase.OnClicked(controlId, control, actionType)
        End Sub


        Protected Overrides Sub OnPageLoad()
            myName = _loadParameter     'which one?
            myTitle = myCommon.Title(myName)
            myURL = myCommon.URL(myName)

            buttonSave.Label = myCommon.Text("Save")
            buttonDelete.Label = myCommon.Text("Delete")

            buttonName.Label = myCommon.Text("Name")
            buttonTitle.Label = myCommon.Text("Window Title")
            buttonURL.Label = myCommon.Text("URL")

            labelStatus.Label = myName

            myCommon.ConfigLoad()
            MyBase.OnPageLoad()
        End Sub

#End Region


#Region "Private methods"

        Private Sub OnButtonDelete()
            If (labelStatus.Label = InternetRadioCommon.NewName) Then Return

            myCommon.Delete(labelStatus.Label)
            myCommon.ConfigSave()
            GUIWindowManager.ShowPreviousWindow()
        End Sub


        Private Sub OnButtonSave()
            myCommon.Add(myName, myTitle, myURL)
            myCommon.ConfigSave()
            GUIWindowManager.ShowPreviousWindow()
        End Sub

#End Region

    End Class

End Namespace
