@ECHO OFF
CLS



REM Debug or Release (un/comment appropriately)?
REM ============================================
REM SET DLLType=Debug
SET DLLType=Release



REM Set (this Cmd file) source directory root
REM =========================================
SET "WorkDir=%~dp0"



REM Clear the error info string
REM ===========================
SET ERRINFO=



REM Windows version?
REM ================

SET INPUT=
If Exist "%AllUsersProfile%\Application Data\Team MediaPortal\MediaPortal\MediaPortal.xml" SET INPUT=XP
If Exist "%ProgramData%\Team MediaPortal\MediaPortal\MediaPortal.xml" SET INPUT=Win7

IF /I '%INPUT%'=='' (
	SET ERRINFO=Unknown Windows version!
	GOTO Exit
)



IF /I "%INPUT%"=="XP" (
	SET MPData=%AllUsersProfile%\Application Data\Team MediaPortal\MediaPortal
	SET "MPProg=%ProgramFiles%\Team MediaPortal\MediaPortal
)

IF /I "%INPUT%"=="Win7" (
	echo %ProgramFiles(x86)%
	SET INPUT=%ProgramFiles%

	IF NOT "%ProgramFiles(x86)%" == "" (
		SET INPUT=%ProgramFiles(x86)%
		SET INPUT=%INPUT%)
	)

	SET MPData=%AllUsersProfile%\Team MediaPortal\MediaPortal
	SET MPProg=%INPUT%\Team MediaPortal\MediaPortal
)



REM MediaPortal Skin in use?
REM ========================

find /c /i ">DefaultWide<" "%MPData%\MediaPortal.XML" > NUL
if %ERRORLEVEL% EQU 0 (
	SET SKIN=DefaultWide
        GOTO FoundSkin
)


find /c /i ">Titan<" "%MPData%\MediaPortal.XML" > NUL
if %ERRORLEVEL% EQU 0 (
	SET SKIN=Titan
        GOTO FoundSkin
)



REM Failed to determine skin, ask what it is
REM ----------------------------------------

ECHO ============= SELECT SKIN ----------
ECHO.
ECHO Using unknown skin
ECHO.

SET INPUT=
SET /P INPUT=Please enter skin name:

SET SKIN=%INPUT%



:Foundskin

REM Check skin is valid/there
REM -------------------------

IF /I '%SKIN%'=='' (
	SET ERRINFO=Invalid skin
	GOTO Exit
)

If Not Exist "%MPData%\skin\%SKIN%\fonts.xml" (
	SET ERRINFO=Invalid/Missing skin
	GOTO Exit
)



REM ********** CHANGE THIS SECTION ONLY **********

REM Don't overwrite an existing config
REM ----------------------------------
If Not Exist "%MPData%\InternetRadio.xml" Copy "%WorkDir%InternetRadio.xml" "%MPData%"

REM Copy over the DLLs
REM ------------------
Copy /Y "%WorkDir%bin\%DLLType%\InternetRadioPlugin.dll"	"%MPProg%\plugins\Windows"

REM Copy over the skin files
REM ------------------------
Copy /Y "%WorkDir%DefaultWide\*.xml"				"%MPData%\skin\%SKIN%"
Copy /Y "%WorkDir%DefaultWide\hover_internetradio.png"		"%MPData%\skin\%SKIN%\Media"

REM ********** CHANGE THIS SECTION ONLY **********



:Exit

ECHO.
IF "%ERRINFO%"=="" SET ERRINFO=Setup Completed OK
ECHO %ERRINFO%
SET /P INPUT=Press any key:
